The IPv6 Compact Routing Header (CRH)
Ron Bonica
Juniper Networks
2251 Corporate Park Drive
Herndon
20171
Virginia
USA
rbonica@juniper.net
Yuji Kamite
NTT Communications Corporation
3-4-1 Shibaura, Minato-ku
Tokyo
108-8118
Japan
y.kamite@ntt.com
Andrew Alston
Liquid Telecom
Nairobi
Kenya
Andrew.Alston@liquidtelecom.com
Daniam Henriques
Liquid Telecom
Johannesburg
South Africa
daniam.henriques@liquidtelecom.com
Luay Jalil
Verizon
Richardson
Texas
USA
luay.jalil@one.verizon.com
17 May 2022
INT Area
6man
IPv6
Routing header
This document defines two new Routing header types. Collectively, they are called the Compact Routing Headers (CRH). Individually, they are called CRH-16 and CRH-32.

Introduction
IPv6 source nodes use Routing headers to specify the path that a packet takes to its destination. The IETF has defined several Routing header types. This document defines two new Routing header types. Collectively, they are called the Compact Routing Headers (CRH). Individually, they are called CRH-16 and CRH-32.
The CRH allows IPv6 source nodes to specify the path that a packet takes to its destination. The CRH:
- Can be encoded in relatively few bytes.
- Is designed to operate within a limited domain. (See Section 9).
The following are reasons for encoding the CRH in as few bytes as possible:
- Many ASIC-based forwarders copy headers from buffer memory to on-chip memory. As header sizes increase, so does the cost of this copy.
- Because Path MTU Discovery (PMTUD) is not entirely reliable, many IPv6 hosts refrain from sending packets larger than the IPv6 minimum link MTU (i.e., 1280 bytes). When packets are small, the overhead imposed by large Routing Headers is excessive.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC8174] when, and only when, they appear in all capitals, as shown here.

The Compressed Routing Headers (CRH)
Both CRH versions (i.e., CRH-16 and CRH-32) contain the following fields:
- Next Header - Defined in [RFC8200].
- Hdr Ext Len - Defined in [RFC8200].
- Routing Type - Defined in [RFC8200]. (CRH-16 value is 5. CRH-32 value is 6).
- Segments Left - Defined in [RFC8200].
- Type-specific Data - Described in [RFC8200].
In the CRH, the Type-specific data field contains a list of Segment Identifiers (SIDs). Each SID represents both of the following:
- A segment of the path that the packet takes to its destination.
- An entry in the CRH Forwarding Information Base (CRH-FIB) .
SIDs are listed in reverse order. So, the first SID in the list represents the final segment in the path. Because segments are listed in reverse order, the Segments Left field can be used as an index into the SID list. In this document, the "current SID" is the SID list entry referenced by the Segments Left field.
The first segment in the path can be omitted from the list. See Appendix A for examples.
In the CRH-16, each SID is encoded in 16-bits. In the CRH-32, each SID is encoded in 32-bits.
In all cases, the CRH MUST end on a 64-bit boundary. So, the Type- specific data field MUST be padded with zeros if the CRH would otherwise not end on a 64-bit boundary.

CRH-16
   0                   1                   2                   3
   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  |  Next Header  |  Hdr Ext Len  | Routing Type  | Segments Left |
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  |             SID[0]            |          SID[1]               |
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-|
  |                          .........
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-

CRH-32
   0                   1                   2                   3
   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  |  Next Header  |  Hdr Ext Len  | Routing Type  | Segments Left |
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  +                             SID[0]                            +
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  +                             SID[1]                            +
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  //                                                              //
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  +                             SID[n]                            +
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

The CRH Forwarding Information Base (CRH-FIB)
Each SID identifies a CRH-FIB entry.
Each CRH-FIB entry contains:
- An IPv6 address.
- A topological function.
- Arguments for the topological function. (Optional).
The first ten bits of the IPv6 address MUST NOT be fe00. That prefix is reserved for link-local addresses.
The topological function specifies how the processing node forwards the packet to the next segment endpoint. The following are examples:
- Forward the packet through the least-cost path to the next segment endpoint.
- Forward the packet through a specified interface.
- Encapsulate the packet in another IPv6 header of any type (e.g., MPLS, IPv6) and forward either through the least cost path or a specified interface.
Some topological functions require parameters. For example, a topological function might require a parameter that identifies the interface through which the packet should be forwarded.
The CRH-FIB can be populated:
- By an operator, using a Command Line Interface (CLI).
- By a controller, using the Path Computation Element (PCE) Communication Protocol (PCEP) or the Network Configuration Protocol (NETCONF).
- By a distributed routing protocol [ISO10589-Second-Edition], [RFC5340], [RFC4271].

Processing Rules
The following rules describe CRH processing:
- If Segments Left equals 0, skip over the CRH and process the next header in the packet.
- If Hdr Ext Len indicates that the CRH is larger than the implementation can process, discard the packet and send an ICMPv6 Parameter Problem, Code 0, message to the Source Address, pointing to the Hdr Ext Len field.
- Compute L, the minimum CRH length ( Section 5.1).
- If L is greater than Hdr Ext Len, discard the packet and send an ICMPv6 Parameter Problem, Code 0, message to the Source Address, pointing to the Segments Left field.
- Decrement Segments Left.
- Search for the current SID in the CRH-FIB. In this document, the "current SID" is the SID list entry referenced by the Segments Left field.
- If the search does not return a CRH-FIB entry, discard the packet and send an ICMPv6 Parameter Problem, Code 0, message to the Source Address, pointing to the current SID.
- If Segments Left is greater than 0 and the CRH-FIB entry contains a multicast address, discard the packet and send an ICMPv6 Parameter Problem, Code 0, message to the Source Address, pointing to the current SID.
- Copy the IPv6 address from the CRH-FIB entry to the Destination Address field in the IPv6 header.
- Decrement the IPv6 Hop Limit.
- Submit the packet, its topological function and its parameters to the IPv6 module. See NOTE.
NOTE: By default, the IPv6 module determines the next-hop and forwards the packet. However, the topological function may elicit another behavior. For example, the IPv6 module may forward the packet through a specified interface.

Computing Minimum CRH Length
The algorithm described in this section accepts the following CRH fields as its input parameters:
- Routing Type (i.e., CRH-16 or CRH-32).
- Segments Left.
It yields L, the minimum CRH length. The minimum CRH length is measured in 8-octet units, not including the first 8 octets.
<CODE BEGINS>

switch(Routing Type) {
    case CRH-16:
        if (Segments Left <= 2)
            return(0)
        sidsBeyondFirstWord = Segments Left - 2;
        sidPerWord = 4;
    case CRH-32:
        if (Segments Left <= 1)
            return(0)
        sidsBeyondFirstWord = Segments Left - 1;
        sidsPerWord = 2;
    case default:
        return(0xFF);
    }

words = sidsBeyondFirstWord div sidsPerWord;
if (sidsBeyondFirstWord mod sidsPerWord)
    words++;

return(words)

<CODE ENDS>

Mutability
In the CRH, the Segments Left field is mutable. All remaining fields are immutable.

Applications And SIDs
A CRH contains one or more SIDs. Each SID is processed by exactly one node.
Therefore, a SID is not required to have domain-wide significance. Applications can:
- Allocate SIDs so that they have domain-wide significance.
- Allocate SIDs so that they have node-local significance.

Management Considerations
PING and TRACEROUTE both operate correctly in the presence of the CRH.

Security Considerations
Networks that process the CRH MUST NOT accept packets containing the CRH from outside of there limited domain.. Their border routers SHOULD discard packets that satisfy the following criteria:
- The packet contains a CRH
- The Segments Left field in the CRH has a value greater than 0
- The Destination Address field in the IPv6 header represents an interface that resides inside of the network.
Many border routers cannot filter packets based upon the Segments Left value. These border routers MAY discard packets that satisfy the following criteria:
- The packet contains a CRH
- The Destination Address field in the IPv6 header represents an interface that resides inside of the network.

Implementation and Deployment Status
Juniper Networks has produced experimental implementations of the CRH on:
- A LINUX-based software platform
- The MX-series (ASIC-based) router
Liquid Telecom has deployed the CRH, on a limited basis, in their network. Other experimental deployments are in progress.

IANA Considerations
This document makes the following registrations in the "Internet Protocol Version 6 (IPv6) Parameters" "Routing Types" subregistry maintained by IANA:
         +-------+------------------------------+---------------+
         | Value | Description                  | Reference     |
         +=======+==============================+===============+
         | 5     | CRH-16                       | This document |
         +-------+------------------------------+---------------+
         | 6     | CRH-32                       | This document |
         +-------+------------------------------+---------------+

Acknowledgements
Thanks to Dr. Vanessa Ameen, Fernando Gont, Naveen Kottapalli, Joel Halpern, Tony Li, Gerald Schmidt, Nancy Shaw, Ketan Talaulikar, and Chandra Venkatraman for their contributions to this document.

Contributors
Gang Chen
Baidu
No.10 Xibeiwang East Road Haidian District
Beijing 100193 P.R. China
Email: phdgang@gmail.com
Yifeng Zhou
ByteDance
Building 1, AVIC Plaza, 43 N 3rd Ring W Rd Haidian District
Beijing 100000 P.R. China
Email: yifeng.zhou@bytedance.com
Gyan Mishra
Verizon
Silver Spring, Maryland, USA
Email: hayabusagsm@gmail.com

Normative References

Informative References
[IANA-RH]

Routing Headers
IANA
[ISO10589-Second-Edition]

"Intermediate system to Intermediate system intra-domain routeing information exchange protocol for use in conjunction with the protocol for providing the connectionless-mode Network Service (ISO 8473)", ISO/IEC 10589:2002, Second Edition,
International Organization for Standardization
November 2001
[RFC8174]
[RFC8200]
[RFC5340]
[RFC4271]

CRH Processing Examples
This appendix demonstrates CRH processing in the following scenarios:
- The SID list contains one entry for each segment in the path .
- The SID list omits the first entry in the path .

Reference Topology

 -----------                 -----------                 -----------
|Node: S    |               |Node: I1   |               |Node: I2   |
|Loopback:  |---------------|Loopback:  |---------------|Loopback:  |
|2001:db8::a|               |2001:db8::1|               |2001:db8::2|
 -----------                 -----------                 -----------
      |                                                       |
      |                      -----------                      |
      |                     |Node: D    |                     |
       ---------------------|Loopback:  |---------------------
                            |2001:db8::b|
                             -----------

Figure 3 provides a reference topology that is used in all examples.

Node SIDs
SID | IPv6 Address | Forwarding Method
2 | 2001:db8::2 | Least-cost path
11 | 2001:db8::b | Least-cost path
Table 1 describes two entries that appear in each node's CRH-FIB.

The SID List Contains One Entry For Each Segment In The Path
In this example, Node S sends a packet to Node D, via I2. In this example, I2 appears in the CRH segment list.
As the packet travels from S to I2: |
Source Address = 2001:db8::a | Segments Left = 1
Destination Address = 2001:db8::2 | SID[0] = 11
| SID[1] = 2
As the packet travels from I2 to D: |
Source Address = 2001:db8::a | Segments Left = 0
Destination Address = 2001:db8::b | SID[0] = 11
| SID[1] = 2

The SID List Omits The First Entry In The Path
In this example, Node S sends a packet to Node D, via I2. In this example, I2 does not appear in the CRH segment list.
As the packet travels from S to I2: |
Source Address = 2001:db8::a | Segments Left = 1
Destination Address = 2001:db8::2 | SID[0] = 11
As the packet travels from I2 to D: |
Source Address = 2001:db8::a | Segments Left = 0
Destination Address = 2001:db8::b | SID[0] = 11